{% extends "page.html" %}
{% from "components.html" import availability %}
{% macro show_attr(person, attr, description) %}
    <form>
        <div class="form-group row single-value-property" data-attr="{{ attr }}">
            <label for="input-{{ attr }}" class="col-sm-3 col-form-label">{{ description }}</label>
            <div class="col-sm-9">
                <div class="input-group editable-field">
                    <input
                        type="text"
                        class="form-control readonly-on-view"
                        id="input-{{ attr }}"
                        placeholder="{{ description }}"
                        name="{{ attr }}"
                        value="{{ person[attr] or '' }}"
                        readonly="readonly"/>
                    <div class="input-group-append hide-on-view">
                        <button type="submit" class="btn btn-outline-secondary">Update</button>
                    </div>
                </div>
            </div>
        </div>
    </form>
{% endmacro %}
{% macro fixed_attr(person, attr, description) %}
    <form>
        <div class="form-group row single-value-property" data-attr="{{ attr }}">
            <label for="input-{{ attr }}" class="col-sm-3 col-form-label">{{ description }}</label>
            <div class="col-sm-9">
                <div class="input-group editable-field">
                    <input
                        type="text"
                        class="form-control {{ edit_class }}"
                        id="input-{{ attr }}"
                        placeholder="{{ description }}"
                        name="{{ attr }}"
                        value="{{ person[attr] or '' }}"
                        readonly="readonly"/>
                </div>
            </div>
        </div>
    </form>
{% endmacro %}
{% macro show_attr_list(person, attr, field, desc_field = None, description = None, special = None) %}
    <div
        class="row multi-property-list my-3"
        data-attr="{{ attr }}"
        data-description="{{ description }}"
        data-field="{{ field }}"
        {{ 'data-desc-field=' + desc_field if desc_field }}
        {{ 'data-special=' +  special if special }}>
        <div class="col-sm-3 attr-label">
            {{ description }}
        </div>
        <div class="col-sm-9 itemised-properties">
            {% for item in person[attr] %}
                <div class="mb-2">
                    <div class="multi-attribute text-nowrap" data-item="{{ item|tojson|forceescape }}">
                        <span class="attr-value">
                            {% if special == 'email' %}
                                <a href="mailto:{{ item[field] }}" title="Compose email in default mail client">
                                    {{ item[field] }}
                                </a>
                                <a
                                    href="https://webmail.hermes.cam.ac.uk/?_task=mail&_action=compose&_to={{ item[field] }}"
                                    title="Compose new email in Hermes Webmail"
                                    target="_blank">✉</a>
                                <a
                                    href="https://outlook.office.com/mail/deeplink/compose/?to={{ item[field] }}"
                                    title="Compose new email in Exchange Online"
                                    target="_blank">
                                    <span class="owa-logo"></span></a>
                            {% elif special == 'address' %}
                                {% for line in item[field].splitlines() %}
                                    {{ line }}<br/>
                                {% endfor %}
                            {% elif special == 'url' %}
                                {% if item[desc_field] %}
                                    <a href="{{ item[field] }}" class="hidden-interact">
                                        <span class="hidden-interact-popup">{{ item[field] }}</span>
                                        {{ item[desc_field] }}
                                    </a>
                                {% else %}
                                    <a href="{{ item[field] }}">
                                        {{ item[field] }}
                                    </a>
                                {% endif %}
                            {% else %}
                                {{ item[field] }}
                            {% endif %}
                        </span>
                        <span class="attr-desc {{ 'd-none' if special == 'url' }}">
                            {% if item[desc_field] %}
                                ({{ item[desc_field] }})
                            {% endif %}
                        </span>
                        <button
                            class="btn btn-sm btn-outline-secondary border-0 btn-mod-attr hide-on-view"
                            title="Modify this entry">
                            <span class="fas fa-pencil-alt"></span></button>
                        <button
                            class="btn btn-sm btn-outline-secondary border-0 btn-del-attr hide-on-view"
                            title="Delete this entry">
                            <span class="far fa-trash-alt"></span></button>
                    </div>
                </div>
            {% endfor %}
            <form class="hide-on-view">
                <div class="form-group">
                    <div class="input-group mt-0 mb-3 add-attr" id="add-{{ attr }}-group">
                        {% if special == 'email' %}
                            <input
                                class="form-control"
                                title="add-{{ attr }}"
                                placeholder="New {{ description }}"
                                name="{{ attr }}-{{ field }}"
                                id="add-{{ attr }}-{{ field }}"
                                type="email"/>
                        {% elif special == 'url' %}
                            <input
                                class="form-control"
                                title="add-{{ attr }}"
                                placeholder="New {{ description }}"
                                name="{{ attr }}-{{ field }}"
                                id="add-{{ attr }}-{{ field }}"
                                type="url"/>
                        {% elif special == 'address' %}
                            <textarea
                                class="form-control"
                                title="add-{{ attr }}"
                                placeholder="New {{ description }}"
                                name="{{ attr }}-{{ field }}"
                                id="add-{{ attr }}-{{ field }}"
                                rows="1"></textarea>
                        {% else %}
                            <input
                                class="form-control"
                                title="add-{{ attr }}"
                                placeholder="New {{ description }}"
                                name="{{ attr }}-{{ field }}"
                                id="add-{{ attr }}-{{ field }}"
                                type="text"/>
                        {% endif %}
                        {% if desc_field %}
                            <input
                                class="form-control"
                                title="add-{{ attr }}"
                                placeholder="Description (optional)"
                                name="{{ attr }}-{{ desc_field }}"
                                id="add-{{ attr }}-{{ desc_field }}"
                                type="text"/>
                        {% endif %}
                        <div class="input-group-append">
                            <button type="submit" class="btn btn-outline-secondary btn-add-attr">Add</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
{% endmacro %}
{% macro show_attr_markdown(person, attr, description) %}
    <form>
        <div class="form-group row single-value-property markdown" data-attr="{{ attr }}">
            <label for="input-{{ attr }}" class="col-sm-3 col-form-label">{{ description }}</label>
            <div class="col-sm-9">
                <div class="editable-field hide-on-view hover-container">
                    <div class="input-group">
                        <textarea
                            class="form-control markdown resize:vertical readonly-on-view"
                            id="input-{{ attr }}"
                            placeholder="{{ description }}"
                            readonly="readonly"
                            rows="8">{{ person[attr] or '' }}</textarea>
                        <div class="input-group-append">
                            <button type="submit" class="btn btn-outline-secondary">Update</button>
                        </div>
                    </div>
                    <div class="hover-content alert alert-secondary">
                        Field supports
                        <a href="http://commonmark.org/help/">markdown</a>
                        formatting.
                        <table class="table table-striped table-sm" id="cheat-sheet">
                            <tbody>
                                <tr>
                                    <td>
                                        <code># header<br/>## subheader</code>
                                    </td>
                                    <td>
                                        <h2>headers</h2>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <code>paragraphs<br/><br/>paragraphs</code>
                                    </td>
                                    <td>
                                        <p>paragraphs</p>
                                        <p>paragraphs</p>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <code>* item<br/>* list</code>
                                    </td>
                                    <td>
                                        <ul>
                                            <li>item</li>
                                            <li>list</li>
                                        </ul>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <code>_italics_<br/>**bold**</code>
                                    </td>
                                    <td>
                                        <i>italics</i><br/>
                                        <strong>bold</strong>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <code>[link text](link URL)</code>
                                    </td>
                                    <td>
                                        <a id="linkURL" href="#linkURL">link text</a>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <code>---</code>
                                    </td>
                                    <td>
                                        <hr/>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <code>`code`<br/>```multiline code```</code>
                                    </td>
                                    <td>
                                        <code>code</code><br/>
                                        <code>multiline code</code>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <a href="https://markdown-it.github.io/">And more...</a>
                        <div id="cheat-sheet-out"></div>
                    </div>
                </div>
                <div class="rendered-markdown hide-on-edit mx-3" id="rendered-{{ attr }}"></div>
            </div>
        </div>
    </form>
{% endmacro %}
{% macro show_attr_select(person, attr, field, description, values = None) %}
    <form>
        <div class="row select-value-property" data-attr="{{ attr }}" data-field="{{ field }}">
            <label for="input-{{ attr }}" class="col-sm-3 col-form-label">{{ description }}</label>
            <div class="col-sm-9">
                <div class="input-group select-buttons">
                    {% for value in values %}
                        <div class="form-check form-check-inline toggle pr-0 mr-0">
                            <input
                                class="form-check-input toggle disable-on-view"
                                type="checkbox"
                                id="{{ attr }}-{{ field }}-{{ value }}"
                                value="{{ value }}"
                                disabled="disabled"
                                {% if value in person[attr]|map(attribute=field) %}
                                checked="checked"
                                {% endif %}/>
                            <label class="form-check-label btn btn-status ml-3" for="{{ attr }}-{{ field }}-{{ value }}">
                                {{ value }}
                            </label>
                        </div>
                    {% endfor %}
                </div>
            </div>
        </div>
    </form>
{% endmacro %}
{% macro show_chat(person) %}
    {% if "chat" in person_data.linked_services or "gitlab" in person_data.linked_services %}
        {% if edit %}
            <div class="row my-3">
                <div class="col-sm-3 attr-label">
                    Linked Services
                </div>
                <div class="col-sm-9 input-group">
                    {% if "chat" in person_data.linked_services %}
                        <div class="text-nowrap">
                            <a
                                class="chat-link d-inline-block ml-3"
                                href="{{ person_data.linked_services.chat.url }}"
                                target="_blank"></a>
                            <form class="d-inline-block">
                                <div
                                    class="select-value-property form-check form-check-inline toggle text-nowrap"
                                    data-linked-service="chat"
                                    data-attr="hidden">
                                    <input
                                        class="toggle hide-link vis-switch disable-on-view"
                                        type="checkbox"
                                        id="hide-chat"
                                        disabled="disabled"
                                        {{ 'checked' if person_data.linked_services.chat.hidden }}/>
                                    <label class="form-check-label btn btn-status ml-3" for="hide-chat"></label>
                                </div>
                            </form>
                        </div>
                    {% endif %}
                    {% if "gitlab" in person_data.linked_services %}
                        <div class="text-nowrap">
                            <a
                                class="gitlab-link d-inline-block ml-3"
                                href="{{ person_data.linked_services.gitlab.url }}"
                                target="_blank"></a>
                            <form class="d-inline-block">
                                <div
                                    class="select-value-property form-check form-check-inline toggle text-nowrap"
                                    data-linked-service="gitlab"
                                    data-attr="hidden">
                                    <input
                                        class="toggle hide-link vis-switch disable-on-view"
                                        type="checkbox"
                                        id="hide-gitlab"
                                        disabled="disabled"
                                        {{ 'checked' if person_data.linked_services.gitlab.hidden }}/>
                                    <label class="form-check-label btn btn-status ml-3" for="hide-gitlab"></label>
                                </div>
                            </form>
                        </div>
                    {% endif %}
                </div>
            </div>
        {% else %}
            {% if "chat" in person_data.linked_services and not person_data.linked_services.chat.hidden or "gitlab" in person_data.linked_services and not person_data.linked_services.gitlab.hidden %}
                <div class="row my-3">
                    <div class="col-sm-3 attr-label">
                        Linked Services
                    </div>
                    <div class="col-sm-9 input-group">
                        {% if "chat" in person_data.linked_services %}
                            {% if not person_data.linked_services.chat.hidden %}
                                <a class="chat-link ml-3" href="{{ person_data.linked_services.chat.url }}" target="_blank"></a>
                            {% endif %}
                        {% endif %}
                        {% if "gitlab" in person_data.linked_services %}
                            {% if not person_data.linked_services.gitlab.hidden %}
                                <a class="gitlab-link ml-3" href="{{ person_data.linked_services.gitlab.url }}" target="_blank"></a>
                            {% endif %}
                        {% endif %}
                    </div>
                </div>
            {% endif %}
        {% endif %}
    {% endif %}
{% endmacro %}
{% block title %}
    {{ g.site.short_name }}
    -
    {{ person_data.display_name or person_data.crsid }}
{% endblock %}
{% block content %}
    <div id="person-info" data-crsid="{{ person_data.crsid }}" data-mode="view">
        <div class="card">
            <div class="card-header d-flex justify-content-between">
                <div>
                    <h3 id="display-name">{{ person_data.display_name }}</h3>
                    <div class="lead">
                        <a
                            id="lookup-cam-link"
                            data-crsid="{{ person_data.crsid }}"
                            class="font-weight-bold mr-1"
                            href="https://www.lookup.cam.ac.uk/person/crsid/{{ person_data.crsid }}"
                            title="Link to profile on lookup.cam"
                            target="_blank">
                            <code>{{ person_data.crsid }}</code>
                        </a>
                        {% for institution in person_data.institutions %}
                            <a
                                class="badge badge-secondary"
                                data-instid="{{ institution.instid }}"
                                href="{{ url_for('web.people', scope=institution.instid) }}"
                                title="{{ institution.name or '' }}">
                                {{ institution.instid }}
                            </a>
                        {% endfor %}
                    </div>
                </div>
                <div id="card-header-right">
                    {% if edit %}
                        <div
                            id="availability-info"
                            class="row justify-content-end align-items-center mb-2 h5"
                            title="Availability until {{ person_data.availability_expiry or 'reset' }}">
                            {% if person_data.availability %}
                                <span id="availability-text">{{ person_data.availability_text or '' }}</span>
                                <div class="mx-2">
                                    {{ availability(person_data.availability_indicator, "availability-indicator", person_data.availability_expiry) }}
                                </div>
                            {% else %}
                                <span id="availability-text"></span>
                                <div class="mx-2">
                                    {{ availability(None, "availability-indicator") }}
                                </div>
                            {% endif %}
                            <button
                                id="availability-update"
                                type="button"
                                title="Update availability information"
                                data-toggle="modal"
                                data-target="#availability-update-modal"
                                class="btn btn-outline-secondary btn-sm hide-on-view border-0">
                                <span class="fas fa-pencil-alt"></span></button>
                        </div>
                    {% elif person_data.availability %}
                        <div
                            id="availability-info"
                            class="row justify-content-end align-items-center mb-2 h5"
                            title="Availability until {{ person_data.availability_expiry }}">
                            <span id="availability-text">{{ person_data.availability_text or '' }}</span>
                            <div class="mx-2">
                                {{ availability(person_data.availability_indicator, "availability-indicator", person_data.availability_expiry) }}
                            </div>
                        </div>
                    {% endif %}
                    {% if edit %}
                        <div id="tag-edit-controls" class="row justify-content-end">
                            <div class="select-value-property form-check form-check-inline toggle" data-attr="hidden">
                                <input
                                    class="form-check-input toggle vis-switch disable-on-view"
                                    type="checkbox"
                                    id="hide-profile"
                                    disabled="disabled"
                                    {{ 'checked' if person_data.hidden }}/>
                                <label class="form-check-label btn btn-status ml-3" for="hide-profile"></label>
                            </div>
                            <button class="text-muted text-nowrap btn btn-lg btn-light px-2 py-1 mx-3" id="edit-toggle">
                                <span class="fas fa-edit"></span>&nbsp;Edit</button>
                        </div>
                    {% endif %}
                </div>
            </div>
            <div class="card-body py-1">
                <form class="form-group row single-value-property mb-0" data-attr="headline">
                    <div class="input-group editable-field">
                        <input
                            type="text"
                            class="form-control form-control-lg h4 readonly-on-view"
                            id="input-headline"
                            placeholder="Headline"
                            name="headline"
                            value="{{ person_data.headline or '' }}"
                            aria-label="Headline"
                            readonly="readonly"/>
                        <div class="input-group-append hide-on-view">
                            <button type="submit" class="btn btn-outline-secondary">Update</button>
                        </div>
                    </div>
                </form>
            </div>
            <hr class="my-0"/>
            <div class="card-body">
                <div class="row mb-3 d-flex justify-content-between">
                    <div class="col" id="person-info">
                        {{ show_attr(person_data, 'display_name', 'Display Name') }}
                        {{ fixed_attr(person_data, 'crsid', 'CRSid') }}
                        {{ show_attr_list(person_data, 'titles', 'text', None, 'Title') }}
                        {{ show_attr(person_data, 'first_name', 'First Name') }}
                        {{ show_attr(person_data, 'surname', 'Surname') }}
                        {{ show_attr(person_data, 'pronouns', 'Pronouns') }}
                        {{ show_attr_select(person_data, 'status', 'name', 'Status', all_statuses) }}
                        {{ show_chat(person_data) }}
                        {{ show_attr_list(person_data, 'email_addresses', 'address', 'description', 'Email Address', 'email') }}
                        {{ show_attr_list(person_data, 'telephone_numbers', 'number', 'description', 'Telephone Number') }}
                        {{ show_attr_list(person_data, 'addresses', 'address', 'description', 'Postal address', 'address') }}
                        {{ show_attr_list(person_data, 'urls', 'url', 'description', 'Website', 'url') }}
                        {{ show_attr_markdown(person_data, 'profile', 'Profile') }}
                    </div>
                    <div class="col-md-3" id="photo">
                        <form id="photo-upload" class="position-relative" enctype="multipart/form-data">
                            <button
                                id="photo-delete"
                                type="button"
                                title="Remove photo from profile"
                                class="btn btn-outline-secondary hide-on-view bg-light position-absolute m-1">
                                <span class="far fa-trash-alt"></span>
                            </button>
                            <div id="photo-container" class="text-center">
                                {% if person_data.photo %}
                                    <img
                                        class="rounded right w-100"
                                        src="data:image/jpeg;base64, {{ person_data.photo }}"
                                        alt="photo"
                                        id="person-photo"/>
                                {% else %}
                                    <span class="fas fa-user photo-placeholder"></span>
                                {% endif %}
                            </div>
                            <div id="photo-upload-controls" class="hide-on-view">
                                <label for="photo-upload">Replace photo (or drag and drop)</label>
                                <div class="input-group">
                                    <div class="custom-file">
                                        <input type="file" class="custom-file-input" name="photo" id="photo-upload-input"/>
                                        <label class="custom-file-label" for="photo-upload">Choose</label>
                                    </div>
                                    <div class="input-group-append">
                                        <button class="btn btn-outline-secondary" type="submit">✔</button>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
                <div class="list-group-item" id="personal-tags">
                    <div class="d-flex justify-content-between">
                        <h5>Tags</h5>
                    </div>
                    <ul class="list-inline tag-list">
                        {% for tag in person_data.tags %}
                            <a
                                href="{{ url_for('web.tag', name=tag.name) }}"
                                class="list-inline-item btn btn-tag my-2 tag"
                                data-tag="{{ tag.name }}"
                                title="{{ tag.description or '' }}">
                                {{ tag.name }}
                                <button
                                    class="btn btn-sm btn-outline-light btn-del-attr border-0 hide-on-view"
                                    title="Remove tag from profile">
                                    <span class="far fa-trash-alt"></span></button>
                            </a>
                        {% endfor %}
                        <div class="form-group list-inline-item my-0 dropdown hide-on-view" id="tag-quick-search">
                            <input
                                class="form-control"
                                title="quick-search"
                                placeholder="Search or create Tags"
                                name="query"
                                id="tag-quick-search-input"
                                type="text"/>
                            <div id="tag-quick-search-output"></div>
                        </div>
                    </ul>
                    <div class="hide-on-view">
                        <ul class="list-inline tag-list" id="tag-suggestions"></ul>
                    </div>
                </div>
                <div class="list-group-item" id="room-list">
                    <h5>Rooms</h5>
                    <ul class="list-inline rooms">
                        {% for room in person_data.rooms %}
                            <a
                                href="{{ url_for('web.room', identifier=room.identifier) }}"
                                class="list-inline-item btn btn-room room my-1"
                                {% if room.description %}
                                title="{{ room.description }}"
                                {% endif %}
                                data-item="{{ room|tojson|forceescape }}">
                                {% if room.building %}
                                    {{ room.building }}
                                    -
                                    {{ room.number }}
                                {% else %}
                                    {{ room.number }}
                                {% endif %}
                                <button
                                    class="btn btn-sm btn-outline-dark btn-del-attr hide-on-view border-0"
                                    title="Remove room from profile">
                                    <span class="far fa-trash-alt"></span></button>
                            </a>
                        {% endfor %}
                        <div class="form-group list-inline-item dropdown hide-on-view" id="room-quick-search">
                            <div class="input-group my-1 add-attr" id="room-input">
                                <select class="custom-select custom-room" id="room-building-select" title="room-building-select">
                                    <option selected="selected">Building</option>
                                    {% for building in g.site.buildings %}
                                        <option value="{{ building }}">{{ building }}</option>
                                    {% endfor %}
                                </select>
                                <input
                                    class="form-control custom-room"
                                    title="quick-search"
                                    placeholder="Search Rooms"
                                    name="query"
                                    id="room-quick-search-input"
                                    type="text"/>
                            </div>
                            <div id="room-quick-search-output"></div>
                        </div>
                    </ul>
                </div>
                <div class="list-group-item" id="hierarchy">
                    <h5>Reporting structure</h5>
                    <div class="text-center" id="line-managers">
                        <ul class="list-inline managers">
                            {% for manager in person_data.line_managers %}
                                <a
                                    class="list-inline-item btn btn-primary manager my-1"
                                    href="{{ url_for('web.person', crsid=manager.crsid) }}"
                                    data-crsid="{{ manager.crsid }}">
                                    {{ manager.display_name }}
                                    <button
                                        class="btn btn-sm btn-outline-light btn-del-attr border-0 hide-on-view"
                                        title="Remove managerial relationship">
                                        <span class="far fa-trash-alt"></span></button>
                                </a>
                            {% endfor %}
                            <div class="form-group list-inline-item my-1 dropdown hide-on-view" id="manager-quick-search">
                                <input
                                    class="form-control"
                                    title="quick-search"
                                    placeholder="Search for manager"
                                    name="query"
                                    id="manager-quick-search-input"
                                    type="text"/>
                                <div id="manager-quick-search-output"></div>
                            </div>
                        </ul>
                    </div>
                    <hr/>
                    <div class="text-center">
                        <a
                            class="list-inline-item btn btn-primary manager my-1"
                            href="{{ url_for('web.person', crsid=person_data.crsid) }}">
                            {{ person_data.display_name }}
                        </a>
                    </div>
                    <hr/>
                    <div class="text-center" id="subordinates">
                        <ul class="list-inline subordinates">
                            {% for subordinate in person_data.subordinates %}
                                <a
                                    class="list-inline-item btn btn-primary subordinate my-1"
                                    href="{{ url_for('web.person', crsid=subordinate.crsid) }}"
                                    data-crsid="{{ subordinate.crsid }}">
                                    {{ subordinate.display_name }}
                                    <button
                                        class="btn btn-sm btn-outline-light btn-del-attr border-0 hide-on-view"
                                        title="Remove managerial relationship">
                                        <span class="far fa-trash-alt"></span></button>
                                </a>
                            {% endfor %}
                            <div class="form-group list-inline-item my-1 dropdown hide-on-view" id="subordinate-quick-search">
                                <input
                                    class="form-control"
                                    title="quick-search"
                                    placeholder="Search for subordinate"
                                    name="query"
                                    id="subordinate-quick-search-input"
                                    type="text"/>
                                <div id="subordinate-quick-search-output"></div>
                            </div>
                        </ul>
                    </div>
                </div>
                {% if edit %}
                    <div class="list-group-item hide-on-view" id="person-actions">
                        <h5>Actions</h5>
                        <button id="person-delete" type="button" class="btn btn-danger">
                            <span class="far fa-trash-alt"></span>
                            Delete Profile
                        </button>
                    </div>
                {% endif %}
                {% if get_current_user() in config.SUPER_ADMINISTRATORS %}
                    <div class="list-group-item" id="person-extra-info">
                        <h5>Admin Panel</h5>
                        <div class="select-value-property form-check form-check-inline toggle my-3" data-attr="cancelled">
                            <input
                                class="toggle vis-switch disable-on-view"
                                type="checkbox"
                                id="cancel-profile"
                                disabled="disabled"
                                {{ 'checked' if person_data.cancelled }}/>
                            <label class="form-check-label btn btn-outline btn-status ml-3" for="cancel-profile"></label>
                        </div>
                        <div class="card">
                            <div class="card-header" id="extra-heading">
                                <h5 class="mb-0">
                                    <button class="btn btn-link collapsed" data-toggle="collapse" data-target="#extra-content">
                                        <code>Raw data</code>
                                    </button>
                                </h5>
                            </div>
                            <div id="extra-content" class="collapse" data-parent="#person-extra-info">
                                <div class="card-body">
                                    <pre><code>
                                    {{ person_data|pprint }}
                                    </code></pre>
                                </div>
                            </div>
                        </div>
                    </div>
                {% endif %}
            </div>
        </div>
        {% if edit %}
            <div class="modal fade" id="availability-update-modal" tabindex="-1" role="dialog">
                <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">Set your availability</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body p-3">
                            <form>
                                <fieldset class="form-group" id="input-availability-indicator">
                                    <div class="row">
                                        <label class="col-form-label col-2">Indicator</label>
                                        <div class="col-sm-10 btn-group-toggle" data-toggle="buttons">
                                            <label class="btn btn-outline-tertiary m-1" title="Available/Online">
                                                <input
                                                    class="form-check-input"
                                                    type="radio"
                                                    name="indicator"
                                                    {% if person_data.availability_indicator == 'online' %}
                                                    checked="checked"
                                                    {% endif %}
                                                    value="online"/>
                                                <span class="availability-indicator online"></span>
                                            </label>
                                            <label class="btn btn-outline-tertiary m-1" title="Idle">
                                                <input
                                                    class="form-check-input"
                                                    type="radio"
                                                    name="indicator"
                                                    {% if person_data.availability_indicator == 'idle' %}
                                                    checked="checked"
                                                    {% endif %}
                                                    value="idle"/>
                                                <span class="availability-indicator idle"></span>
                                            </label>
                                            <label class="btn btn-outline-tertiary m-1" title="Away">
                                                <input
                                                    class="form-check-input"
                                                    type="radio"
                                                    name="indicator"
                                                    {% if person_data.availability_indicator == 'away' %}
                                                    checked="checked"
                                                    {% endif %}
                                                    value="away"/>
                                                <span class="availability-indicator away"></span>
                                            </label>
                                            <label class="btn btn-outline-tertiary m-1" title="Offline">
                                                <input
                                                    class="form-check-input"
                                                    type="radio"
                                                    name="indicator"
                                                    {% if person_data.availability_indicator == 'offline' %}
                                                    checked="checked"
                                                    {% endif %}
                                                    value="offline"/>
                                                <span class="availability-indicator offline"></span>
                                            </label>
                                            <label class="btn btn-outline-tertiary m-1" title="Unavailable">
                                                <input
                                                    class="form-check-input"
                                                    type="radio"
                                                    name="indicator"
                                                    {% if person_data.availability_indicator == 'unavailable' %}
                                                    checked="checked"
                                                    {% endif %}
                                                    value="unavailable"/>
                                                <span class="availability-indicator unavailable"></span>
                                            </label>
                                            <label class="btn btn-outline-tertiary m-1" title="Do not disturb">
                                                <input
                                                    class="form-check-input"
                                                    type="radio"
                                                    name="indicator"
                                                    {% if person_data.availability_indicator == 'do-not-disturb' %}
                                                    checked="checked"
                                                    {% endif %}
                                                    value="do-not-disturb"/>
                                                <span class="availability-indicator do-not-disturb"></span>
                                            </label>
                                        </div>
                                    </div>
                                </fieldset>
                                <div class="form-group row">
                                    <label for="input-availability-text" class="col-sm-2 col-form-label">Message</label>
                                    <div class="col-sm-10 dropright">
                                        <input
                                            class="form-control"
                                            id="input-availability-text"
                                            data-toggle="dropdown"
                                            value="{{ person_data.availability_text or '' }}"
                                            placeholder="Short description of current status"/>
                                        <div class="dropdown-menu p-0 border-0 ml-2">
                                            <div class="list-group">
                                                {% for suggestion in config.AVAILABILITY_SUGGESTIONS %}
                                                    <a
                                                        href="#"
                                                        class="list-group-item list-group-item-action availability-suggestion py-1"
                                                        title="Click to fill with suggestion">{{ suggestion }}</a>
                                                {% endfor %}
                                                <a
                                                    href="#"
                                                    class="list-group-item list-group-item-action availability-suggestion"
                                                    title="Click to clear"></a>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label class="col-form-label col-2">Duration</label>
                                    <div class="col-sm-10 form-inline">
                                        <label class="mr-sm-2">
                                            <input
                                                type="text"
                                                size="1"
                                                pattern="[0-9]*"
                                                class="form-control mr-1"
                                                id="input-availability-days"/>days</label>
                                        <label class="mr-sm-2">
                                            <input
                                                type="text"
                                                size="1"
                                                pattern="[0-9]*"
                                                class="form-control mr-1"
                                                id="input-availability-hours"/>hours</label>
                                        <label class="mr-sm-2">
                                            <input
                                                type="text"
                                                size="1"
                                                pattern="[0-9]*"
                                                class="form-control mr-1"
                                                id="input-availability-minutes"/>mins</label>
                                    </div>
                                </div>
                                <div
                                    class="form-group row {{ 'd-none' if not person_data.availability }}"
                                    id="input-availability-expiry">
                                    <label class="col-form-label col-2"></label>
                                    <div class="col-sm-10 form-inline">
                                        <p>Currently set until
                                            <span id="input-availability-until">{{ person_data.availability_expiry }}</span></p>
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button type="button" id="save-availability" class="btn btn-primary">Save changes</button>
                            <button type="button" id="clear-availability" class="btn btn-danger">Clear availability</button>
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        </div>
                    </div>
                </div>
            </div>
        {% endif %}
    </div>
{% endblock %}